window.Gleam.initSearch([{"doc":"gleam_javascript","title":"gleam_javascript","content":"# Gleam JavaScript 🌼\n\nWork with JavaScript types and values in Gleam.\n\n## Installation\n\nAdd this package to your Gleam project.\n\n```shell\ngleam add gleam_javascript\n```\n\n## Features\n\nThis library contains modules for working with...\n\n- Arrays\n- Mutable references\n- Promises\n- Symbols\n- `typeof`\n","url":"index.html"},{"doc":"gleam/javascript","title":"Reference","content":"pub type Reference(value)\n\n\nSynonyms:\ngleam/javascript.Reference\ngleam/javascript Reference","url":"gleam/javascript.html#Reference"},{"doc":"gleam/javascript","title":"Symbol","content":"pub type Symbol\n\n\nSynonyms:\ngleam/javascript.Symbol\ngleam/javascript Symbol","url":"gleam/javascript.html#Symbol"},{"doc":"gleam/javascript","title":"TypeOf","content":"pub type TypeOf {\n  UndefinedType\n  ObjectType\n  BooleanType\n  NumberType\n  BigIntType\n  StringType\n  SymbolType\n  FunctionType\n}\n\nUndefinedType\n\n\nObjectType\n\n\nBooleanType\n\n\nNumberType\n\n\nBigIntType\n\n\nStringType\n\n\nSymbolType\n\n\nFunctionType\n\n\nSynonyms:\ngleam/javascript.TypeOf\ngleam/javascript TypeOf","url":"gleam/javascript.html#TypeOf"},{"doc":"gleam/javascript","title":"dereference","content":"pub fn dereference(a: Reference(a)) -&gt; a\n\nSynonyms:\ngleam/javascript.dereference\ngleam/javascript dereference","url":"gleam/javascript.html#dereference"},{"doc":"gleam/javascript","title":"get_symbol","content":"pub fn get_symbol(a: String) -&gt; Symbol\n\nSynonyms:\ngleam/javascript.get_symbol\ngleam/javascript get_symbol","url":"gleam/javascript.html#get_symbol"},{"doc":"gleam/javascript","title":"make_reference","content":"pub fn make_reference(a: a) -&gt; Reference(a)\n\nSynonyms:\ngleam/javascript.make_reference\ngleam/javascript make_reference","url":"gleam/javascript.html#make_reference"},{"doc":"gleam/javascript","title":"reference_equal","content":"pub fn reference_equal(a: Reference(a), b: Reference(a)) -&gt; Bool\n\nSynonyms:\ngleam/javascript.reference_equal\ngleam/javascript reference_equal","url":"gleam/javascript.html#reference_equal"},{"doc":"gleam/javascript","title":"set_reference","content":"pub fn set_reference(a: Reference(a), b: a) -&gt; a\n\nSynonyms:\ngleam/javascript.set_reference\ngleam/javascript set_reference","url":"gleam/javascript.html#set_reference"},{"doc":"gleam/javascript","title":"type_of","content":"pub fn type_of(a: a) -&gt; TypeOf\n\nSynonyms:\ngleam/javascript.type_of\ngleam/javascript type_of","url":"gleam/javascript.html#type_of"},{"doc":"gleam/javascript","title":"update_reference","content":"pub fn update_reference(ref: Reference(a), f: fn(a) -&gt; a) -&gt; a\n\nSynonyms:\ngleam/javascript.update_reference\ngleam/javascript update_reference","url":"gleam/javascript.html#update_reference"},{"doc":"gleam/javascript","title":"gleam/javascript","content":"","url":"gleam/javascript.html"},{"doc":"gleam/javascript/array","title":"Array","content":"pub type Array(element)\n A JavaScript array, in Gleam!\n\n Unlike most data structures in Gleam this one is mutable.\n\n\nSynonyms:\ngleam/javascript/array.Array\ngleam/javascript/array Array","url":"gleam/javascript/array.html#Array"},{"doc":"gleam/javascript/array","title":"fold","content":"pub fn fold(\n  over over: Array(a),\n  from from: b,\n  with with: fn(b, a) -&gt; b,\n) -&gt; b\n Reduces a list of elements into a single value by calling a given function\n on each element, going from left to right.\n\n `fold(from_list([1, 2, 3]), 0, add)` is the equivalent of\n `add(add(add(0, 1), 2), 3)`.\n\n Runs in linear time.\n\nSynonyms:\ngleam/javascript/array.fold\ngleam/javascript/array fold","url":"gleam/javascript/array.html#fold"},{"doc":"gleam/javascript/array","title":"fold_right","content":"pub fn fold_right(\n  over over: Array(a),\n  from from: b,\n  with with: fn(b, a) -&gt; b,\n) -&gt; b\n Reduces a list of elements into a single value by calling a given function\n on each element, going from right to left.\n\n `fold_right(from_list([1, 2, 3]), 0, add)` is the equivalent of\n `add(add(add(0, 3), 2), 1)`.\n\n Runs in linear time.\n\nSynonyms:\ngleam/javascript/array.fold_right\ngleam/javascript/array fold_right","url":"gleam/javascript/array.html#fold_right"},{"doc":"gleam/javascript/array","title":"from_list","content":"pub fn from_list(a: List(a)) -&gt; Array(a)\n Convert a Gleam list to a JavaScript array.\n\n Runs in linear time.\n\nSynonyms:\ngleam/javascript/array.from_list\ngleam/javascript/array from_list","url":"gleam/javascript/array.html#from_list"},{"doc":"gleam/javascript/array","title":"get","content":"pub fn get(a: Array(a), b: Int) -&gt; Result(a, Nil)\n Get the element at the given index.\n\n # Examples\n\n \n &gt; get(from_list([2, 4, 6]), 1)\n Ok(4)\n \n\n \n &gt; get(from_list([2, 4, 6]), 4)\n Error(Nil)\n \n\nSynonyms:\ngleam/javascript/array.get\ngleam/javascript/array get","url":"gleam/javascript/array.html#get"},{"doc":"gleam/javascript/array","title":"map","content":"pub fn map(a: Array(a), with with: fn(a) -&gt; b) -&gt; Array(b)\n Returns a new array containing only the elements of the first array after\n the function has been applied to each one.\n\n Runs in linear time.\n\n # Examples\n\n \n &gt; map(from_list([2, 4, 6]), fn(x) { x * 2 })\n from_list([4, 8, 12])\n \n\nSynonyms:\ngleam/javascript/array.map\ngleam/javascript/array map","url":"gleam/javascript/array.html#map"},{"doc":"gleam/javascript/array","title":"size","content":"pub fn size(a: Array(a)) -&gt; Int\n Get the number of elements in the array.\n\n Runs in constant time.\n\nSynonyms:\ngleam/javascript/array.size\ngleam/javascript/array size","url":"gleam/javascript/array.html#size"},{"doc":"gleam/javascript/array","title":"to_list","content":"pub fn to_list(a: Array(a)) -&gt; List(a)\n Convert a JavaScript array to a Gleam list.\n\n Runs in linear time.\n\nSynonyms:\ngleam/javascript/array.to_list\ngleam/javascript/array to_list","url":"gleam/javascript/array.html#to_list"},{"doc":"gleam/javascript/array","title":"gleam/javascript/array","content":"","url":"gleam/javascript/array.html"},{"doc":"gleam/javascript/map","title":"Map","content":"pub type Map(key, value)\n\n\nSynonyms:\ngleam/javascript/map.Map\ngleam/javascript/map Map","url":"gleam/javascript/map.html#Map"},{"doc":"gleam/javascript/map","title":"get","content":"pub fn get(a: Map(a, b), b: a) -&gt; Result(b, Nil)\n\nSynonyms:\ngleam/javascript/map.get\ngleam/javascript/map get","url":"gleam/javascript/map.html#get"},{"doc":"gleam/javascript/map","title":"new","content":"pub fn new() -&gt; Map(a, b)\n\nSynonyms:\ngleam/javascript/map.new\ngleam/javascript/map new","url":"gleam/javascript/map.html#new"},{"doc":"gleam/javascript/map","title":"set","content":"pub fn set(a: Map(a, b), b: a, c: b) -&gt; Map(a, b)\n\nSynonyms:\ngleam/javascript/map.set\ngleam/javascript/map set","url":"gleam/javascript/map.html#set"},{"doc":"gleam/javascript/map","title":"size","content":"pub fn size(a: Map(a, b)) -&gt; Int\n\nSynonyms:\ngleam/javascript/map.size\ngleam/javascript/map size","url":"gleam/javascript/map.html#size"},{"doc":"gleam/javascript/map","title":"gleam/javascript/map","content":"","url":"gleam/javascript/map.html"},{"doc":"gleam/javascript/promise","title":"Promise","content":"pub type Promise(value)\n\n\nSynonyms:\ngleam/javascript/promise.Promise\ngleam/javascript/promise Promise","url":"gleam/javascript/promise.html#Promise"},{"doc":"gleam/javascript/promise","title":"await","content":"pub fn await(a: Promise(a), b: fn(a) -&gt; Promise(b)) -&gt; Promise(b)\n\nSynonyms:\ngleam/javascript/promise.await\ngleam/javascript/promise await","url":"gleam/javascript/promise.html#await"},{"doc":"gleam/javascript/promise","title":"await2","content":"pub fn await2(a: Promise(a), b: Promise(b)) -&gt; Promise(#(a, b))\n\nSynonyms:\ngleam/javascript/promise.await2\ngleam/javascript/promise await2","url":"gleam/javascript/promise.html#await2"},{"doc":"gleam/javascript/promise","title":"await3","content":"pub fn await3(\n  a: Promise(a),\n  b: Promise(b),\n  c: Promise(c),\n) -&gt; Promise(#(a, b, c))\n\nSynonyms:\ngleam/javascript/promise.await3\ngleam/javascript/promise await3","url":"gleam/javascript/promise.html#await3"},{"doc":"gleam/javascript/promise","title":"await4","content":"pub fn await4(\n  a: Promise(a),\n  b: Promise(b),\n  c: Promise(c),\n  d: Promise(d),\n) -&gt; Promise(#(a, b, c, d))\n\nSynonyms:\ngleam/javascript/promise.await4\ngleam/javascript/promise await4","url":"gleam/javascript/promise.html#await4"},{"doc":"gleam/javascript/promise","title":"await5","content":"pub fn await5(\n  a: Promise(a),\n  b: Promise(b),\n  c: Promise(c),\n  d: Promise(d),\n  e: Promise(e),\n) -&gt; Promise(#(a, b, c, d, e))\n\nSynonyms:\ngleam/javascript/promise.await5\ngleam/javascript/promise await5","url":"gleam/javascript/promise.html#await5"},{"doc":"gleam/javascript/promise","title":"await6","content":"pub fn await6(\n  a: Promise(a),\n  b: Promise(b),\n  c: Promise(c),\n  d: Promise(d),\n  e: Promise(e),\n  f: Promise(f),\n) -&gt; Promise(#(a, b, c, d, e, f))\n\nSynonyms:\ngleam/javascript/promise.await6\ngleam/javascript/promise await6","url":"gleam/javascript/promise.html#await6"},{"doc":"gleam/javascript/promise","title":"await_array","content":"pub fn await_array(a: Array(Promise(a))) -&gt; Promise(Array(a))\n\nSynonyms:\ngleam/javascript/promise.await_array\ngleam/javascript/promise await_array","url":"gleam/javascript/promise.html#await_array"},{"doc":"gleam/javascript/promise","title":"await_list","content":"pub fn await_list(xs: List(Promise(a))) -&gt; Promise(List(a))\n\nSynonyms:\ngleam/javascript/promise.await_list\ngleam/javascript/promise await_list","url":"gleam/javascript/promise.html#await_list"},{"doc":"gleam/javascript/promise","title":"map","content":"pub fn map(a: Promise(a), b: fn(a) -&gt; b) -&gt; Promise(b)\n\nSynonyms:\ngleam/javascript/promise.map\ngleam/javascript/promise map","url":"gleam/javascript/promise.html#map"},{"doc":"gleam/javascript/promise","title":"map_try","content":"pub fn map_try(\n  promise: Promise(Result(a, b)),\n  callback: fn(a) -&gt; Result(c, b),\n) -&gt; Promise(Result(c, b))\n\nSynonyms:\ngleam/javascript/promise.map_try\ngleam/javascript/promise map_try","url":"gleam/javascript/promise.html#map_try"},{"doc":"gleam/javascript/promise","title":"new","content":"pub fn new(a: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Promise(a)\n\nSynonyms:\ngleam/javascript/promise.new\ngleam/javascript/promise new","url":"gleam/javascript/promise.html#new"},{"doc":"gleam/javascript/promise","title":"rescue","content":"pub fn rescue(a: Promise(a), b: fn(Dynamic) -&gt; a) -&gt; Promise(a)\n\nSynonyms:\ngleam/javascript/promise.rescue\ngleam/javascript/promise rescue","url":"gleam/javascript/promise.html#rescue"},{"doc":"gleam/javascript/promise","title":"resolve","content":"pub fn resolve(a: a) -&gt; Promise(a)\n\nSynonyms:\ngleam/javascript/promise.resolve\ngleam/javascript/promise resolve","url":"gleam/javascript/promise.html#resolve"},{"doc":"gleam/javascript/promise","title":"tap","content":"pub fn tap(\n  promise: Promise(a),\n  callback: fn(a) -&gt; b,\n) -&gt; Promise(a)\n\nSynonyms:\ngleam/javascript/promise.tap\ngleam/javascript/promise tap","url":"gleam/javascript/promise.html#tap"},{"doc":"gleam/javascript/promise","title":"try_await","content":"pub fn try_await(\n  promise: Promise(Result(a, b)),\n  callback: fn(a) -&gt; Promise(Result(c, b)),\n) -&gt; Promise(Result(c, b))\n\nSynonyms:\ngleam/javascript/promise.try_await\ngleam/javascript/promise try_await","url":"gleam/javascript/promise.html#try_await"},{"doc":"gleam/javascript/promise","title":"gleam/javascript/promise","content":"","url":"gleam/javascript/promise.html"}]);